\documentclass[a4paper,11pt,american]{article}

\usepackage[margin=2.5cm]{geometry}

\usepackage[utf8]{inputenc}
\usepackage[lighttt]{lmodern}
\ttfamily
\DeclareFontShape{OT1}{lmtt}{m}{it}{<->sub*lmtt/m/sl}{}
\usepackage{microtype}
\usepackage{hyperref}

\usepackage[autopunct]{csquotes}
\MakeOuterQuote{"}

\usepackage{amsmath,amssymb,amsthm}
\usepackage[bbgreekl]{mathbbol}
\usepackage{stmaryrd}
\allowdisplaybreaks

\usepackage{enumitem}
\setlist{noitemsep}

\usepackage{thmtools,thm-patch}
\theoremstyle{plain}
\declaretheorem{theorem}
\declaretheorem[sibling=theorem]{proposition}
\declaretheorem[sibling=theorem]{lemma}
\declaretheorem[sibling=theorem]{corollary}
\declaretheorem[sibling=theorem]{observation}
\theoremstyle{definition}
\declaretheorem[sibling=theorem]{definition}
\declaretheorem[sibling=theorem]{algorithm}
\declaretheorem[sibling=theorem,title=API]{api}

\usepackage{listings}
\usepackage{lstautogobble}
\lstset{
  %backgroundcolor=\color{white},
  %aboveskip=2pt,
  %belowskip=-10pt,
  xleftmargin=\parindent,
  columns=fullflexible,
  autogobble=true,
  numbers=left,
  numberstyle=\tiny\rmfamily\scshape,%\color{darkgray},
  numbersep=\dimexpr(\parindent-6pt),
  morecomment=[l]{//},
  commentstyle=\small\rmfamily\itshape,
  texcl=true,
  mathescape=true,
  literate=
    {...}{{$\ldots$}}2
}

\usepackage{tikz}
\usetikzlibrary{arrows.meta}
\usetikzlibrary{automata}
\usetikzlibrary{decorations.pathmorphing}
% Disable tikz error message when run inside listings math mode
\makeatletter
\global\let\tikz@ensure@dollar@catcode=\relax
\makeatother

\usepackage{tabto}

\usepackage[left,mathlines]{lineno}
\linenumbers

\usepackage{authblk}
%\author[1]{(anonymized for double-blind review)}
\author[1]{Grzegorz Herman}
\affil[1]{\footnotesize
  Theoretical Computer Science, Jagiellonian University
  \authorcr
  \texttt{gherman@tcs.uj.edu.pl}
}

\usepackage{datetime}
\usdate
\usepackage{filemod}
\renewcommand*{\thefilemoddate}[3]{\formatdate{#3}{#2}{#1}}
\date{\filemodprintdate{\jobname}}

\title{Relational parsing:\\a fast, clean, general parsing strategy\\for context-free languages}

\begin{document}
\TabPositions{.4\textwidth}

\newcommand{\con}{{\cdot}}
\newcommand{\cons}{\cdots}
\newcommand{\deq}{\triangleq}
\newcommand{\deriv}[2][]{^{\textup{#1}(#2)}}
\newcommand{\derives}[1][~]{%
  \mathrel{%
    \begin{tikzpicture}[baseline={(base)}]
    \node[inner sep=.6ex,align=center,scale=.7] (tmp) {$#1$};
    \node (base) at ([yshift=-.6ex]tmp.south) {};
    \draw[double distance=.2ex,-{Implies[length=.5ex,width=1.2ex]}] (tmp.south west) -- (tmp.south east);
    \end{tikzpicture}
    }
  }
\newcommand{\edge}[1][~]{%
  \mathrel{%
    \begin{tikzpicture}[baseline={(base)}]
    \node[inner sep=.6ex,align=center,scale=.7] (tmp) {$#1$};
    \node (base) at ([yshift=-.6ex]tmp.south) {};
    \draw[-{To[length=.5ex,width=1.2ex]}] (tmp.south west) -- (tmp.south east);
    \end{tikzpicture}
    }
  }
\newcommand{\efree}[1]{\overline{#1}}
%\renewcommand{\flat}[1]{\langle#1\rangle}
\newcommand{\lderives}[1][~]{%
  \mathrel{%
    \begin{tikzpicture}[baseline={(base)}]
    \node[inner sep=.6ex,align=center,scale=.7] (tmp) {$#1$};
    \node (base) at ([yshift=-.6ex]tmp.south) {};
    \draw[double distance=.2ex,{Square[length=.3ex,width=.8ex]}-{Implies[length=.5ex,width=1.2ex]}] (tmp.south west) -- (tmp.south east);
    \end{tikzpicture}
    }
  }
\newcommand{\position}{{\bullet}}
\newcommand{\nulling}[1]{\underline{#1}}
\newcommand{\positive}{\hspace{-.9ex}_p\hspace{.4ex}}
\newcommand{\produces}{\rightarrow}
\newcommand{\rev}[1]{{%
    \begin{tikzpicture}[baseline={(tmp.base)}]
    \node[inner sep=0pt,outer sep=0pt] (tmp) {$#1$};
    \draw[-{To[width=.8ex]}] ([yshift=.5ex]tmp.north east) -- ([yshift=.5ex]tmp.north west);
    \end{tikzpicture}
  }}
\newcommand{\rul}[1]{\textup{rule}(#1)}
\newcommand{\suchthat}{\ :\ }
\newcommand{\start}{_{\texttt{start}}}
\newcommand{\TP}{\mathbb{\Psi}}
\newcommand{\TS}{\mathbb{\Sigma}}
\newcommand{\term}[1]{{\boldmath\textbf{#1}\unboldmath}}

\maketitle
\begin{abstract}
    We present a novel parsing algorithm for all context-free languages.
    The algorithm features a clean mathematical formulation:
    parsing is expressed as a series of standard operations on \emph{regular} languages and relations.
    Parsing complexity w.r.t. input length matches the state of the art:
    it is worst-case cubic, quadratic for unambiguous grammars, and linear for LR-regular ones.
    What distinguishes our approach is that parsing can be implemented using only immutable, acyclic data structures.
    With a proper choice of these structures,
    a vast majority of operations performed during parsing typical programming languages can be memoized.
    This allows our proof-of-concept implementation to outperform common generalized parsing algorithms,
    in many cases by two orders of magnitude---%
    recognition times for a large Java source corpus are on par with those of the hand-coded, deterministic parser from the Java compiler.
\end{abstract}
\newpage


\section{Introduction}
\label{sec:introduction}

Parsing is a well-studied and yet still active topic in computer science.
Multiple highly efficient deterministic parsers can handle large families of unambiguous context-free grammars, and oftentimes more.
However, grammars of many programming languages do not naturally fit within the limitations required by these parsers, and need tedious manual adaptation
(e.g., replacing left recursion with right recursion).
Worse, such adaptation needs to be "undone" on parse trees, in order to make them reflect the desired structure of the language.
Further, in many cases the "natural" grammar of a language allows some ambiguity, which is easier resolved at a later compilation step.
With the growing need for rapid development of new languages,
generalized parsers---able to handle all, even ambiguous, context-free grammars---are gaining wider adoption.

Most generalized parsing techniques are based on clever parallel simulation of nondeterministic choices of a pushdown automaton.
Some of these algorithms offer good complexity guarantees: worst-case cubic, quadratic on unambiguous grammars, and in some cases linear on "nice" language fragments.
Nondeterminism is handled by means of (some variant of) a data structure called GSS (graph-structured stack).
This makes the constant factors involved significantly larger than in deterministic parsers, which use a simple stack.
Moreover, in order to handle the full class of context-free grammars,
the graph-like data structures in \emph{all} these algorithms need to be \emph{mutable} and allow \emph{cycles}.
Even where it does not significantly complicate the implementation,
it makes reasoning about the algorithm more difficult.

We present a new generalized context-free parsing algorithm which we call \term{relational parsing}.
Similarly to existing approaches, it simulates possible runs of a pushdown automaton.
However, its formulation is based on precise mathematical semantics, given in Sections~\ref{sec:recognition} and~\ref{sec:nullables}:
it inductively computes the languages of configurations reachable after reading consecutive input symbols.
We show that each such language can be obtained from the previous one by a constant number of simple, well-known language-theoretic operations:
union, concatenation, and Brzozowski derivatives.
The way of representing these languages (and their grammar-dependent atomic building blocks) is left abstract at this point.

We give possible concrete realizations of the above abstract data types in Section~\ref{sec:representations}.
We prove that the atomic building blocks are regular languages,
and represent them by nondeterministic finite automata, precomputed from the grammar.
For the languages computed during parsing, we use a DAG structure akin to the graph-structured stack.
However, with our approach, all cyclicity is embedded in the atomic automata,
and we \emph{never} need to add edges to existing DAG nodes.
The input-related complexity of the combined algorithm, discussed in Section~\ref{sec:complexity}, matches the state of the art:
our parser is worst-case cubic, quadratic on unambiguous grammars, and linear on LR-regular grammars.

There are multiple practical benefits of our clean, semantic approach.
The automata representing atomic languages can be optimized.
More importantly, due to immutability, partial results can be memoized and reused.
In Section~\ref{sec:memoization} we outline how to achieve such reuse using a more complex representation of languages.
On practical inputs (Java~8 grammar and a large set of inputs)
it allows a \emph{vast majority} of computation phases to be performed on a plain stack,
which makes our (unoptimized) proof-of-concept C$^\sharp$ implementation significantly outperform (our, unoptimized implementation of) GLL.
In recognition mode the speed-up is close to \emph{two orders of magnitude}---%
the running times are on par with those of the optimized, hand-coded deterministic parser used by the official Java compiler.

Finally, in concluding Section~\ref{sec:related} we discuss how our approach fits into the generalized parsing landscape.
We show how the bits and pieces of our algorithm relate to the seminal work of Lang, Earley, and Tomita,
as well as to GLL, GLR, GLC (generalized left-corner), reduction-incorporated parsers,
parsing-with-derivatives, and Adaptive LL(*) employed by ANTLR4.
Within the discussion we also hint at some places where our algorithm could be improved.

Due to space restrictions, this conference paper only presents the algorithm for context-free \emph{recognition}.
However, our approach generalizes cleanly to a full parser---%
instead of languages of reachable configurations, we compute the relations between configurations and the ways in which they can be reached
(hence the algorithm name).
The algorithm can actually work over an arbitrary semiring:
this includes recognition, parsing, counting parse trees, and other useful types of queries (cf.~\cite{semiring}).
A manuscript with the details of the fully general approach is available at \url{https://www.arxiv.org/abs/1902.06591}.
Our proof-of-concept implementation can be accessed at \url{https://gitlab.com/alt-lang/research/relational-parsing}.%
\footnote{Currently, both the manuscript and the implementation use recursive transition networks instead of context-free grammars,
as this makes it easier to accommodate additional useful features, like regular expressions in the right-hand sides of derivation rules.
Here, we have opted for the most standard definitions in order to make the presentation more accessible.}


\section{Recognition}
\label{sec:recognition}

Let us begin with a quick review of some standard definitions.

\begin{definition}
    A \term{context-free grammar} consists of:
    \begin{itemize}
        \item a finite set $T$ of \term{terminals},
        \item a finite set $N$ of \term{nonterminals}, disjoint from $T$,
        \item a distinguished \term{start symbol} $s\start \in N$, and
        \item a finite set $D$ of \term{derivation rules}, each of the form $s \produces \sigma$,
            with $s \in N$ and $\sigma \in (N \cup T)^*$.
    \end{itemize}
\end{definition}

For the rest of this paper we assume to be working with a single grammar $G$,
and thus consider $T$, $N$, $s\start$, and $D$ to be fixed.
For convenience, let us denote by $S$ the combined set of \term{symbols} of $G$,
i.e., $S \deq T \cup N$.

\begin{definition}
    A \term{(leftmost) derivation step} (denoted $\derives$)
    consists of taking a word over $S$ and replacing its leftmost nonterminal $s$ with the right-hand side $\sigma$ of some rule $(s \produces \sigma) \in D$, i.e.,
    \[ \tau \con s \con \gamma \derives \tau \con \sigma \con \gamma \quad\text{for any}\quad \tau \in T^*, \gamma \in S^*. \]
    The derivation step is \term{left-linear} (denoted $\lderives$) if $\tau = \epsilon$.
    A leftmost (left-linear) \term{derivation} is a finite (possibly empty) sequence of leftmost (left-linear) derivation steps.
    Finally, the grammar \term{generates} a word $\tau$ if $s\start \derives[*] \tau$.
\end{definition}

Our recognition algorithm computes, for successively longer prefixes of the recognized string,
languages (over $S$) which capture the possible completions of these prefixes:

\begin{definition}
    For a string $\tau \in T^*$, we say that a language $\Sigma \subseteq S^*$ is \term{$\tau$-parsing} if
    for every $\gamma \in S^*$ we have
    \[
        s\start \derives[*] \tau \con \gamma
        \quad\iff\quad
        \sigma \derives[*] \gamma \text{ for some } \sigma \in \Sigma.
    \]
\end{definition}

The process begins with the language $\Sigma_\epsilon \deq \{ s\start \}$
which obviously is $\epsilon$-parsing.
Computing further parsing languages is based on the following simple concept:

\begin{definition}
    The \term{left-linear closure} of a language $\Sigma \subseteq S^*$ is the language
    \[ [\Sigma] \deq \{ \sigma' \in S^* \suchthat \sigma \lderives[*] \sigma' \text{ for some } \sigma \in \Sigma \}. \]
\end{definition}

We will also need the standard notion of language derivatives, due to Brzozowski~\cite{Brzozowski}:

\begin{definition}
    The \term{derivative} of a language $\Sigma \subseteq S^*$ by a symbol $s \in S$ is the language
    \[ \Sigma\deriv{s} \deq \{ \sigma' \in S^* \suchthat s \con \sigma' \in \Sigma \}. \]
\end{definition}

The dependency between parsing languages for consecutively longer input strings
can now be formally stated as follows:

\begin{proposition}
    \label{prop:step-raw}
    If $\Sigma$ is $\tau$-parsing, then $[\Sigma]\deriv{t}$ is $(\tau \con t)$-parsing.
\end{proposition}
\begin{proof}
    Take a $\gamma \in S^*$ such that $s\start \derives[*] \tau \con t \con \gamma$.
    As $\Sigma$ is $\tau$-parsing, there exists a $\sigma \in \Sigma$ such that $\sigma \derives[*] t \con \gamma$.
    Take any leftmost derivation
    \[ \sigma = \sigma_0 \derives \sigma_1 \derives \ldots \derives \sigma_m = t \con \gamma, \]
    and let $k$ be the smallest index for which $\sigma_k = t \con \sigma'$ for some $\sigma'$.

    Clearly, each step leading to $\sigma_k$ must apply some rule to the initial nonterminal of the current string.
    Thus, this part of the derivation is left-linear and we have $t \con \sigma' \in [\Sigma]$, and hence $\sigma' \in [\Sigma]\deriv{t}$.
    The remaining part of the derivation cannot change the initial terminal $t$, and thus $\sigma' \derives[*] \gamma$.

    Conversely, if $\sigma' \derives[*] \gamma$ for some $\sigma' \in [\Sigma]\deriv{t}$,
    then $s\start \lderives[*] t \con \sigma' \derives[*] \gamma$,
    which concludes the proof that $[\Sigma]\deriv{t}$ is $(\tau \con t)$-parsing.
\end{proof}

In order to recognize a string $\tau = t_1 \cons t_n$ one can thus start with the language $\Sigma_\epsilon$,
inductively compute $\Sigma_{t_1 \cons t_k} \deq [\Sigma_{t_1 \cons t_{k-1}}]\deriv{t_k}$
(we call each such computation a \term{phase}),
and finally check whether $\epsilon \in [\Sigma_\tau]$.

To gain an intuition of what the languages $\Sigma_\tau$ really are,
recall the textbook construction of a pushdown automaton recognizing the language generated by our grammar.
The stack of such PDA holds strings over $S$.
Each transition pops a symbol $s$ and either matches it against the next input terminal,
or replaces it with the right-hand side $\sigma$ of some rule $(s \produces \sigma) \in D$.
Each language $\Sigma_\tau$ now contains precisely the stacks of this PDA possible immediately after consuming the string $\tau$.

Before we show how the required left-linear closure of a language can be obtained using more primitive operations,
let us temporarily assume that the grammar has no nullable symbols,
i.e. that $s \derives[*] \epsilon$ does not hold for any $s \in S$.
Every grammar which does not generate the empty string can be transformed into such form,
but in Section~\ref{sec:nullables} we will handle nullable symbols slightly differently.

\begin{proposition}
    \label{prop:step}
    Suppose there are no nullable symbols.
    Then for every language $\Sigma \subseteq S^*$ and symbol $t \in S$ we have
    \[ [\Sigma]\deriv{t} = \bigcup_{s \in S} [s]\deriv{t} \con \Sigma\deriv{s}. \]
\end{proposition}
\begin{proof}
    Take $\sigma' \in [\Sigma]\deriv{t}$,
    witnessed by a $\sigma \in \Sigma$ such that $\sigma \lderives[*] t \con \sigma'$.
    As $\sigma$ cannot be empty, there must exist $s \in S$ and $\alpha, \beta \in S^*$ for which
    $\sigma' = \alpha \con \beta$, $\sigma = s \con \beta$, and $s \lderives[*] t \con \alpha$
    (the latter holds because a left-linear derivation from $\sigma$ cannot touch $\beta$, as $s$ is not nullable).
    It follows that $\alpha \in [s]\deriv{t}$ and $\beta \in \Sigma\deriv{s}$,
    which proves the left-to-right inclusion.

    For the other direction, take $\sigma' \in \bigcup_{s \in S} [s]\deriv{t} \con \Sigma\deriv{s}$,
    witnessed by $s \in S$ and $\alpha, \beta \in S^*$ for which
    $\sigma' = \alpha \con \beta$, $t \con \alpha \in [s]$, and $s \con \beta \in \Sigma$.
    Then $s \con \beta \lderives[*] t \con \alpha \con \beta$
    which implies that $\sigma' \in [\Sigma]\deriv{t}$, as required.
\end{proof}

We are now ready to present our top-level recognition algorithm.
Denote by $\mathcal{L}$ the set of \term{atomic languages} of the grammar $G$,
consisting of $\Sigma_{\epsilon}$ and $[s]\deriv{t}$ for each $s \in S$ and $t \in T$.
Assume that we are given a data type $\TS$,
representing languages over $S$ and providing the following \term{primitive operations}:

\begin{itemize}
    \item $\texttt{root}() \in \TS$ \tab represents $\{\epsilon\}$,
    \item $\texttt{prepend}(\Lambda \in \mathcal{L}; \Sigma \in \TS) \in \TS$ \tab represents $\Lambda \con \Sigma$,
    \item $\texttt{derivative}(\Sigma \in \TS; s \in S) \in \TS$ \tab represents $\Sigma\deriv{s}$,
    \item $\texttt{empty}() \in \TS$ \tab represents $\varnothing$,
    \item $\texttt{union}(\Sigma_1, \Sigma_2 \in \TS) \in \TS$ \tab represents $\Sigma_1 \cup \Sigma_2$,
    \item $\texttt{epsilon}(\Sigma \in \TS) \in \{\texttt{true, false}\}$ \tab checks whether $\epsilon \in \Sigma$.
\end{itemize}

Using these operations, our proposed context-free recognition algorithm can be stated as follows:

\begin{algorithm}
    \label{alg:recognition}
    Deciding whether the grammar $G$ generates a string $t_1 \cons t_n \in T^*$.
    \begin{lstlisting}
        $\Sigma := \texttt{prepend}(\Sigma_{\epsilon}, \texttt{root}())$
        for $i = 1, \ldots, n$:
            $\Sigma' := \texttt{empty}()$
            for each $s \in S$:
                $\Sigma' := \texttt{union}(\Sigma', \texttt{prepend}([s]\deriv{t_i}, \texttt{derivative}(\Sigma, s)))$
            $\Sigma := \Sigma'$
        return $\texttt{epsilon}(\Sigma)$
    \end{lstlisting}
\end{algorithm}


\section{Handling nullable symbols}
\label{sec:nullables}

As presented, Algorithm~\ref{alg:recognition} only works for grammars without nullable symbols.
Instead of transforming the grammar to meet this criterion,
we will incorporate the handling of nullables into the construction of atomic languages.
To achieve this, we will focus on derivations that erase nullable symbols as early as possible,
requiring that once a string is placed in a parsing language, none of its symbols can later be erased.
This is embodied in the following two definitions:

\begin{definition}
    A derivation $\sigma \derives[*] \gamma$ is \term{positive} (denoted $\sigma \derives[*]\positive \gamma$)
    if it erases no symbol of $\sigma$,
    i.e., when for some $s_1, \ldots, s_k \in S$ and $\gamma_1, \ldots, \gamma_k \in S^+$ we have
    \[
        \sigma = s_1 \cons s_k, \quad
        \gamma = \gamma_1 \cons \gamma_k, \quad
        \text{and}\quad s_i \derives[*] \gamma_i \text{ for } i = 1 \ldots k.
    \]
\end{definition}

\begin{definition}
    A language $\Sigma$ is \term{positively $\tau$-parsing} if for every $\gamma \in S^*$ we have
    \[
        s\start \derives[*] \tau \con \gamma
        \quad\iff\quad
        \sigma \derives[*]\positive \gamma \text{ for some } \sigma \in \Sigma.
    \]
\end{definition}

Because the only derivations disallowed in the above definition
are those that erase some nullable symbols from a word $\sigma \in \Sigma$,
to account for such derivations it is enough to enrich $\Sigma$ to also contain subsequences of $\sigma$
with every possible subset of such nullable symbols already removed.
To make this intuition formal, we employ the following concept:

\begin{definition}
    \term{Nulling} is the endomorphism of the class of languages over $S$
    (with the image of a language $\Sigma$ denoted $\nulling\Sigma$),
    obtained by extension from the following formula for individual symbols:
    \[
        \nulling{s} \deq \left\{ \begin{array}{ll}
            \{ s, \epsilon \} & \text{if } s \derives[*] \epsilon, \\
            \{ s \} & \text{otherwise.}
        \end{array} \right.
    \]
\end{definition}

\begin{lemma}
    \label{lem:nulling}
    If $\Sigma$ is $\tau$-parsing, then $\nulling{\Sigma}$ is positively $\tau$-parsing.
\end{lemma}
\begin{proof}
    Take any $\sigma \in \Sigma$ and $\gamma \in S^*$ such that $\sigma \derives[*] \gamma$.
    There must exist $s_1, \ldots, s_k \in S$ and $\gamma_1, \ldots, \gamma_k \in S^*$ for which
    \[
        \sigma = s_1 \cons s_k, \quad
        \gamma = \gamma_1 \cons \gamma_k, \quad
        \text{and}\quad s_i \derives[*] \gamma_i \text{ for } i = 1 \ldots k.
    \]

    Let $i_1 < \ldots < i_r$ be the subsequence of $1, \ldots, k$
    consisting of exactly those indices for which $\gamma_{i_j} \neq \epsilon$.
    Taking $\sigma' = s_{i_1} \cons s_{i_r}$,
    we have $\sigma' \in \nulling{\Sigma}$ and $\sigma' \derives[*]\positive \gamma$.
    The other direction is similar.
\end{proof}

We will now replace the use of parsing languages in Algorithm~\ref{alg:recognition} by their (positively parsing) nullings.
To justify the correctness of such step, we will prove an appropriate modification of Proposition~\ref{prop:step}.

\begin{observation}
    \label{obs:nulling-vs-deriv}
    For every language $\Sigma \subseteq S^*$ and symbol $s \in S$, we have
    $\nulling{\Sigma\deriv{s}} \subseteq \nulling\Sigma\deriv{s}$
\end{observation}
\begin{proof}
    Take $\sigma \in \nulling{\Sigma\deriv{s}}$.
    It must be of the form $\sigma = s_1 \cons s_k$
    for some $\eta_0 \con s_1 \con \eta_1 \cons s_k \con \eta_k \in \Sigma\deriv{s}$ with each $\eta_i$ nullable.
    Then $s \con \eta_0 \con s_1 \cons \eta_k \in \Sigma$,
    yielding $s \con s_1 \cons s_k \in \nulling\Sigma$ and $\sigma \in \nulling\Sigma\deriv{s}$.
\end{proof}

\begin{proposition}
    For every language $\Sigma \subseteq S^*$ and symbol $t \in S$ we have
    \[ \nulling{[\Sigma]\deriv{t}} = \bigcup_{s \in S} \nulling{[s]\deriv{t}} \con \nulling{\Sigma}\deriv{s}. \]
\end{proposition}
\begin{proof}
    Consider a $\sigma' \in [\Sigma]\deriv{t}$,
    witnessed by a $\sigma \in \Sigma$ such that $\sigma \lderives[*] t \con \sigma'$.
    As $\sigma$ cannot be empty, there must exist $s \in S$ and $\eta, \alpha, \beta \in S^*$ for which
    $\sigma' = \alpha \con \beta$, $\sigma = \eta \con s \con \beta$, $\eta \lderives[*] \epsilon$, and $s \lderives[*] t \con \alpha$.
    As $\eta$ is nullable, $s \con \beta \in \nulling\Sigma$.
    It follows that $\alpha \in [s]\deriv{t}$ and $\beta \in \nulling\Sigma\deriv{s}$,
    which proves that
    \[ [\Sigma]\deriv{t} \subseteq \bigcup_{s \in S} [s]\deriv{t} \con \nulling\Sigma\deriv{s}. \]
    Now, because nulling is an idempotent, monotone homomorphism, using Observation~\ref{obs:nulling-vs-deriv} we obtain
    \[
        \nulling{[\Sigma]\deriv{t}} \quad\subseteq\quad
        \nulling{\bigcup_{s \in S} [s]\deriv{t} \con \nulling\Sigma\deriv{s}} \quad=\quad
        \bigcup_{s \in S} \nulling{[s]\deriv{t}} \con \nulling{\nulling\Sigma\deriv{s}} \quad\subseteq\quad
        \bigcup_{s \in S} \nulling{[s]\deriv{t}} \con \nulling\Sigma\deriv{s}.
    \]

    For the other direction, take $\sigma \in \bigcup_{s \in S} \nulling{[s]\deriv{t}} \con \nulling\Sigma\deriv{s}$.
    It must be of the form $\sigma = s_1 \cons s_k \con r_1 \cons r_m$,
    with $t \con \sigma_0 \con s_1 \con \sigma_1 \cons s_k \con \sigma_k \in [s]$
    and $\rho \con s \con \rho_0 \con r_1 \con \rho_1 \cons r_m \con \rho_m \in \Sigma$
    for some nullable $\sigma_i$'s, $\rho_i$'s and $\rho$.
    Then we have
    \[
        \rho \con s \con \rho_0 \cons r_m \con \rho_m \lderives[*]
        s \con \rho_0 \cons r_m \con \rho_m \lderives[*]
        t \con \sigma_0 \cons s_k \con \sigma_k \con \rho_0 \cons r_m \con \rho_m \lderives[*]
        t \con \sigma_0 \cons s_k \sigma_k \con \rho_0 \cons r_m \con \rho_m,
    \]
    by which $\sigma_0 \cons s_k \con \sigma_k \con \rho_0 \cons r_m \con \rho_m \in [\Sigma]\deriv{t}$
    and finally $\sigma \in \nulling{[\Sigma]\deriv{t}}$.
\end{proof}

By the above,
we can replace each atomic language in $\mathcal{L}$ and in Algorithm~\ref{alg:recognition} by its nulling,
obtaining a recognition algorithm able to handle arbitrary context-free grammars.


\section{Parse tree construction}
\label{sec:parsing}

We now augment our algorithm to perform generalized parsing and not just mere recognition.
The exposition here mirrors closely the one from Sections~\ref{sec:recognition} and~\ref{sec:nullables}.
All definitions and propositions are adjusted so that instead of asking \emph{whether} some word can de derived,
we recover \emph{the language of reverse leftmost derivations} which derive it.

We will augment the notation for derivations,
placing over the derivation arrow ($\derives$ or $\lderives$) a sequence of (leftmost) derivation steps.

\begin{definition}
    For a string $\tau \in T^*$, we say that a relation $\Phi \subseteq S^*{\times}D^*$ is \term{$\tau$-parsing}
    if for every $\gamma \in S^*$ we have
    \[
        s\start \derives[\delta] \tau \con \gamma
        \quad\iff\quad
        \sigma \derives[\delta_2] \gamma \text{ for some } (\sigma, \rev{\delta_1}) \in \Phi \text{ and } \delta = \delta_1 \con \delta_2.
    \]
\end{definition}

Parsing will now begin with the $\epsilon$-parsing relation $\Phi_\epsilon \deq \{ (s\start, \epsilon) \}$.
To prove the equivalent of Proposition~\ref{prop:step-raw},
we need natural generalizations of left-linear closure and Brzozowski derivatives to relations:

\begin{definition}
    The \term{left-linear closure} of a relation $\Phi \subseteq S^*{\times}D^*$ is the relation
    \[ [\Phi] \deq \{ (\sigma', \rev{\delta_1 \con \delta_2}) \suchthat \sigma \lderives[\delta_2] \sigma' \text{ for some } (\sigma, \rev{\delta_1}) \in \Phi \}. \]
\end{definition}

\begin{definition}
    The \term{derivative} of a relation $\Phi \subseteq S^*{\times}D^*$ by a symbol $s \in S$ is the relation
    \[ \Phi\deriv{s} \deq \{ (\sigma,\rev\delta) \suchthat (s \con \sigma,\rev\delta) \in \Phi \}. \]
\end{definition}

\begin{proposition}
    If $\Phi$ is $\tau$-parsing, then $[\Phi]\deriv{t}$ is $(\tau \con t)$-parsing.
\end{proposition}
\begin{proof}
    Take a $\gamma \in S^*$ such that $s\start \derives[\delta] \tau \con t \con \gamma$.
    As $\Phi$ is $\tau$-parsing, there exist $(\sigma, \rev{\delta_1}) \in \Phi$
    such that $\sigma \derives[\delta_2] t \con \gamma$ with $\delta = \delta_1 \con \delta_2$.
    Unroll the derivation $\delta_2$ as
    \[
        \sigma = \sigma_0 \derives \sigma_1 \derives \ldots \derives \sigma_m = t \con \gamma,
    \]
    and let $k$ be the smallest index for which $\sigma_k = t \con \sigma'$ for some $\sigma'$.
    Split the derivation at this point as $\delta_2 = \delta_{21} \con \delta_{22}$.

    Clearly, each step of $\delta_{21}$ must apply some rule to the initial nonterminal of the current string.
    Thus, this part of the derivation is left-linear and we have
    $(t \con \sigma', \rev{\delta_1 \con \delta_{21}}) \in [\Phi]$, and hence
    $(\sigma', \rev{\delta_1 \con \delta_{21}}) \in [\Phi]\deriv{t}$.
    The remaining part of the derivation ($\delta_{22}$) cannot change the initial terminal $t$
    and thus $\sigma' \derives[\delta_{22}] \gamma$.

    Conversely, if $\sigma' \derives[\delta_2] \gamma$ for some $(\sigma', \rev{\delta_1}) \in [\Phi]\deriv{t}$,
    then $s\start \lderives[\delta_1] t \con \sigma' \derives[\delta_2] \gamma$,
    which concludes the proof that $[\Phi]\deriv{t}$ is $(\tau \con t)$-parsing.
\end{proof}

It turns out that the iterative formula given by Proposition~\ref{prop:step} applies also to parsing relations.
However, in order to handle nullable symbols,
we will first need to adapt the definitions from Section~\ref{sec:nullables}.

Recall that nulling allowed us to remove nullable symbols from the middle of words in a parsing language, making it positively parsing.
This step conceptually corresponds to erasing such symbols as soon as they are introduced---%
in particular, the derivation realizing it might not be leftmost!
In order to recover the leftmost derivation,
instead of silently dropping nullable symbols,
we will replace them with a (sequence of) \emph{pending derivation steps},
which will be included in the derivation when the location of such erased symbol is considered.

To formalize the above intuition, we first introduce the \term{mixed alphabet} $M \deq S \cup D$,
and generalize the notion of derivations for string over $M$:

\begin{definition}
    A \term{mixed (leftmost) derivation step} has one of two forms:
    \begin{align*}
        \tau \con s \con \mu \derives[d] \tau \con \sigma \con \mu
        &\quad\text{for } d = (s \produces \sigma) \in D,
        \quad\text{or}\\
        \tau \con d \con \mu \derives[d] \tau \con \mu
        &\quad\text{for } d \in D,
    \end{align*}
    both for any $\tau \in T^*$ and $\mu \in M^*$.
    The step is \term{left-linear} (denoted $\lderives$) if $\tau = \epsilon$.
\end{definition}

\begin{definition}
    A mixed derivation $\mu \derives[\delta] \gamma$ is \term{positive} (denoted $\mu \derives[\delta]\positive \gamma$)
    if it does not erase any symbol of $\mu$ (it \emph{might} execute pending derivation steps), i.e.,
    when for some $\eta_0 \con \delta_1 \con \eta_1 \cons \delta_k \con \eta_k = \delta$,
    $s_1, \ldots, s_k \in S$, and $\gamma_1, \ldots, \gamma_k \in S^+$ we have
    \[
        \mu = \eta_0 \con s_1 \con \eta_1 \cons s_k \con \eta_k, \quad
        \gamma = \gamma_1 \cons \gamma_k, \quad\text{and}\quad
        s_i \derives[\delta_i] \gamma_i \text{ for } i = 1 \ldots k.
    \]
\end{definition}

We will now work with \term{mixed relations}, i.e., relations over $M^*{\times}D^*$.

\begin{definition}
    A mixed relation $\Psi \subseteq M^*{\times}D^*$ is \term{positively $\tau$-parsing}
    if for every $\gamma \in S^*$ we have
    \[
        s\start \derives[\delta] \tau \con \gamma
        \quad\iff\quad
        \sigma \derives[\delta_2]\positive \gamma \text{ for some } (\sigma, \rev{\delta_1}) \in \Psi \text{ and } \delta = \delta_1 \con \delta_2.
    \]
\end{definition}

The following generalization of nulling turns a (possibly mixed) relation into a mixed relation,
potentially replacing any occurrence of a symbol $s$ by any derivation which erases it:

\begin{definition}
    The \term{nulling} of a (possibly mixed) relation $\Psi \subseteq M^*{\times}D^*$
    is the smallest relation $\nulling\Psi \supseteq \Psi$ with the property that
    for every $\mu_1, \mu_2 \in M^*$, $\delta \in D^*$, $s \in S$ and $s \derives[\eta] \epsilon$ we have
    \[
        (\mu_1 \con s \con \mu_2, \rev\delta) \in \nulling\Psi
        \quad\implies\quad
        (\mu_1 \con \eta \con \mu_2, \rev\delta) \in \nulling\Psi.
    \]
\end{definition}

An equivalent of Lemma~\ref{lem:nulling} is now easily established:

\begin{lemma}
    If $\Phi \subseteq S^*{\times}D^*$ is $\tau$-parsing,
    then $\nulling\Phi \subseteq M^*{\times}D^*$ is positively $\tau$-parsing.
\end{lemma}
\begin{proof}
    Take any $(\sigma, \rev{\delta_1}) \in \Phi$ and $\gamma \in S^*$ such that $\sigma \derives[\delta_2] \gamma$.
    There must exist $s_1, \ldots, s_k \in S$, $\gamma_1, \ldots, \gamma_k \in S^*$ and $\eta_1, \ldots, \eta_k \in D^*$ for which
    \[
        \sigma = s_1 \cons s_k, \quad
        \gamma = \gamma_1 \cons \gamma_k, \quad
        \delta_2 = \eta_1 \cons \eta_k, \quad\text{and }
        s_i \derives[\eta_i] \gamma_i \text{ for } i = 1 \ldots k.
    \]

    Let $i_1 < \ldots < i_r$ be the subsequence of $1, \ldots, k$ consisting of exactly those indices for which $\gamma_{i_j} \neq \epsilon$.
    Taking $\sigma' = \eta_1 \cons \eta_{i_1-1} \con s_{i_1} \con \eta_{i_1+1} \cons \eta_{i_2-1} s_{i_2} \cons s_{i_r} \con \eta_{i_r+1} \cons \eta_k$
    we have $(\sigma', \delta_2) \in \nulling\Phi$ and $\sigma' \derives[\delta_2]\positive \gamma$.
    The other direction is again similar.
\end{proof}

Finally, in order to adapt Algorithm~\ref{alg:recognition} to work with mixed relations,
we need an appropriate notion of derivatives.
As with non-mixed relations, the symbol $s$ by which the derivative is taken should be removed from the top of the left component of the relation.
However, it might now be preceded by some pending derivation steps---%
these need to be "executed", i.e. moved to the second component of the relation.

\begin{definition}
    \label{def:derivative-rel}
    The \term{derivative} of a mixed relation $\Psi \subseteq M^*{\times}D^*$ by a symbol $s \in S$
    is the mixed
    \[
        \Psi\deriv{s} \deq \{ (\mu, \rev{\delta \con \eta}) \suchthat (\eta \con s \con \mu, \rev\delta) \in \Psi \}.
    \]
\end{definition}

\begin{observation}
    \label{obs:nulling-vs-deriv-rel}
    For every mixed relation $\Psi \subseteq M^*{\times}D^*$ and symbol $s \in S$, we have $\nulling{\Psi\deriv{s}} \subseteq \nulling\Psi\deriv{s}$.
\end{observation}

\begin{proposition}
    For every relation $\Phi \subseteq S^*{\times}D^*$ and symbol $t \in S$ we have
    \[
        \nulling{[\Phi]\deriv{t}} = \bigcup_{s \in S} \nulling{[(s, \epsilon)]\deriv{t}} \con \nulling\Phi\deriv{s}.
    \]
\end{proposition}
\begin{proof}
    Consider a $(\sigma', \rev\delta) \in [\Phi]\deriv{t}$,
    witnessed by a $(\sigma, \rev{\delta_1}) \in \Phi$ such that $\sigma \lderives[\delta_2] t \con \sigma'$ with $\delta = \delta_1 \con \delta_2$.
    As $\sigma$ cannot be empty, there must exist $s \in S$, $\eta, \alpha, \beta \in S^*$ and $\delta_{21}, \delta_{22} \in D^*$
    for which $\sigma' = \alpha \con \beta$, $\sigma = \eta \con s \con \beta$, $\eta \lderives[\delta_{21}] \epsilon$, $s \lderives[\delta_{22}] t \con \alpha$, and $\delta_2 = \delta_{21} \con \delta_{22}$.
    Then $(\delta_{21} \con s \con \beta, \rev{\delta_1}) \in \nulling\Phi$.
    It follows that $(\alpha, \rev{\delta_{22}}) \in [(s, \epsilon)]\deriv{t}$ and $(\beta, \rev{\delta_1 \con \delta_{21}}) \in \nulling\Phi\deriv{s}$,
    which proves that
    \[
        [\Phi]\deriv{t} \subseteq \bigcup_{s \in S} [(s, \epsilon)]\deriv{t} \con \nulling\Phi\deriv{s}.
    \]

    Because nulling of relations is an idempotent, monotone homomorphism, using Observation~\ref{obs:nulling-vs-deriv-rel} we obtain
    \[
        \nulling{[\Phi]\deriv{t}} \quad\subseteq\quad
        \nulling{\bigcup_{s \in S} [(s, \epsilon)]\deriv{t} \con \nulling\Phi\deriv{s}} \quad=\quad
        \bigcup_{s \in S} \nulling{[(s, \epsilon)]\deriv{t}} \con \nulling{\nulling\Phi\deriv{s}} \quad\subseteq\quad
        \bigcup_{s \in S} \nulling{[(s, \epsilon)]\deriv{t}} \con \nulling\Phi\deriv{s}.
    \]

    For the other direction, take $(\mu, \rev\delta) \in \bigcup_{s \in S} \nulling{[(s, \epsilon)]\deriv{t}} \con \nulling\Phi\deriv{s}$.
    $\mu$ and $\delta$ must be of the form
    $\mu = \eta_0 \con s_1 \con \eta_1 \cons s_k \con \eta_k \con \lambda_0 \con r_1 \con \lambda_1 \cons r_m \con \lambda_m$ and $\delta = \delta_1 \con \delta_2 \con \delta_3$
    for some $(t \con \sigma_0 \con s_1 \con \sigma_1 \cons s_k \con \sigma_k, \rev{\delta_3}) \in [(s, \epsilon)]$
    and $(\rho \con s \con \rho_0 \con r_1 \con \rho_1 \cons r_m \con \rho_m, \rev{\delta_1}) \in \Phi$
    with $\sigma_i \derives[\eta_i] \epsilon$, $\rho_i \derives[\lambda_i] \epsilon$ and $\rho \derives[\delta_2] \epsilon$.
    But then $(s \con \rho_0 \con r_1 \con \rho_1 \cons r_m \con \rho_m, \rev{\delta_2 \con \delta_3}) \in [\Phi]$,
    implying that $(t \con \sigma_0 \con s_1 \con \sigma_1 \cons s_k \con \sigma_k \con \rho_0 \con r_1 \con \rho_1 \cons r_m \con \rho_m, \rev{\delta_1 \con \delta_2 \con \delta_3}) \in [\Phi]$,
    and finally $(\mu, \rev\delta) \in \nulling{[\Phi]\deriv{t}}$ as required.
\end{proof}

We can now state our main parsing algorithm.
Let $\mathcal{R}$ be the family of \term{atomic relations} for the grammar $G$,
consisting of $\nulling{\Phi\epsilon}$ and $\nulling{[(s, \epsilon)]\deriv{t}}$ for every $s \in S$ and $t \in T$.
Suppose we are given a data type $\TP$ representing mixed relations and supporting the following operations:

\begin{itemize}
    \item $\texttt{root}() \in \TP$ \tab represents $\{(\epsilon, \epsilon)\}$,
    \item $\texttt{prepend}(\Gamma \in \mathcal{R}; \Psi \in \TP) \in \TP$ \tab represents $\Gamma \con \Psi$,
    \item $\texttt{derivative}(\Psi \in \TP; s \in S) \in \TP$ \tab represents $\Psi\deriv{s}$,
    \item $\texttt{empty}() \in \TP$ \tab represents $\varnothing$,
    \item $\texttt{union}(\Psi_1, \Psi_2 \in \TP) \in \TP$ \tab represents $\Psi_1 \cup \Psi_2$,
    \item $\texttt{epsilon}(\Psi \in \TP) \subseteq D^*$ \tab computes $\{ \rev{\delta \con \eta} \suchthat (\eta, \rev\delta) \in \Psi \}$.
\end{itemize}

Then, the following re-statement of Algorithm~\ref{alg:recognition} computes the language of all reverse leftmost derivations of a given terminal string.

\begin{algorithm}
    \label{alg:parsing}
    Computing reverse leftmost derivations of a string $t_1 \cons t_n \in T^*$.
    \begin{lstlisting}
        $\Psi := \texttt{prepend}(\nulling{\Phi_\epsilon}, \texttt{root}())$
        for $i = 1, \ldots, n$:
            $\Psi' := \texttt{empty}()$
            for each $s \in S$:
                $\Psi' := \texttt{union}(\Psi', \texttt{prepend}(\nulling{[(s, \epsilon)]\deriv{t_i}}, \texttt{derivative}(\Psi, s)))$
            $\Psi := \Psi'$
        return $\texttt{epsilon}(\Psi)$
    \end{lstlisting}
\end{algorithm}



\section{Representing languages and relations}
\label{sec:representations}

We will now give appropriate implementations of the data types $\TS$ and $\TP$.


\subsection{Parsing languages}

We begin with a crucial observation about atomic languages:

\begin{lemma}
    \label{lem:atomic-regular}
    The languages $\nulling{\Sigma_\epsilon}$ and $\nulling{[s]\deriv{t}}$ for $s \in S$ and $t \in T$ are regular.
\end{lemma}
\begin{proof}
    $\nulling{\Sigma_\epsilon}$ is finite.
    For $\nulling{[s]\deriv{t}}$ to be regular, it is enough if $[s]$ is.
    To show the latter, imagine a grammar $G_s$ obtained from $G$ as follows:
    \begin{itemize}
        \item the terminal alphabet is $S$,
        \item the nonterminal alphabet is $\{ \hat{n} \suchthat n \in S \}$,
        \item the start symbol is $\hat{s}$,
        \item for each $n \in S$, $G_s$ has a rule $\hat{n} \produces n$,
        \item for each rule $(n \produces s_1 \cdots s_k) \in D$,
            for each $0 \leqslant j \leqslant k$ such that $s_1 \cons s_j \derives[*] \epsilon$,\\
            $G_s$ has a rule $\hat{n} \produces \hat{s_{j+1}} \con s_{j+2} \cons s_k$.
    \end{itemize}
    Now each leftmost derivation in $G_s$ corresponds to some left-linear derivation in $G$ and vice versa,
    and hence $G_s$ generates $[s]$.
    On the other hand, $G_s$ is a left-linear grammar, and thus the language it generates is regular.
    The result follows.
\end{proof}

Being regular, atomic languages can be represented in a multitude of ways.
In our implementation, we use nondeterministic finite automata (without $\epsilon$-transitions),
with the number of states linear in $|G|$.
Such nondeterminism can be captured with the following variant of Brzozowski derivatives:

\begin{definition}
    A \term{split derivative of degree $k$} of a language $\Sigma \subseteq S^*$ by a symbol $s \in S$
    is any collection of languages $\Sigma\deriv[split]{s} = \{ \Sigma_i \}_{i = 1 \ldots k}$ such that for every $\sigma \in S^*$
    \[ s \con \sigma \in \Sigma \quad\iff\quad \sigma \in \bigcup_i \Sigma_i. \]

    A language is \term{$(m,k)$-regular} if it belongs to a family of size $m$ closed under split derivatives of degree $k$.
\end{definition}

The notion of $(m,k)$-regularity is simply a fine-grained equivalent of standard regularity,
with $m$ and $k$ measuring the size and degree of nondeterminism of some automaton recognizing a regular language.
It allows the following refinement of Lemma~\ref{lem:atomic-regular}:

\begin{lemma}
    Atomic languages for the grammar $G$ are $(|G|, |G|)$-regular.
\end{lemma}
\begin{proof}
    This is a simpler version of Lemma~\ref{lem:atomic-regular-rel}, to be shown soon.
\end{proof}

Before we proceed, let us slightly generalize the requirements placed on $\TS$.
Instead of requiring the first argument of \texttt{prepend} to be one of the atomic languages,
let us parameterize $\TS$ with an \emph{arbitrary family} of languages $\mathcal{L}$,
as long as it is finite and closed under split derivatives.
By the above lemma, the family consisting of $\nulling{\Sigma_\epsilon}, \nulling{[s]\deriv{t}}$ and all their (iterated) derivatives meets those criteria.

Denote by $\efree\Sigma$ the $\epsilon$-free part of $\Sigma$, i.e., $\Sigma - \{\epsilon\}$.
Our implementation of $\TS$ is based on the following observation:

\begin{proposition}
  \label{prop:language-shape}
  Let $\Sigma_1, \Sigma_2, \ldots, \Sigma_n$ be a sequence of languages over $S$,
  in which each $\Sigma_i$ is obtained by applying one of the primitive language operations to some $\Sigma_j$ with $j < i$.
  Then there exists a finite collection of pairs $\{ (\Lambda_j, i_j) \}_{j}$ with $\Lambda_j \in \mathcal{L}$ and $1 \leqslant i_j < n$, such that
  \[
    \efree{\Sigma_n} = \bigcup_j \efree{\Lambda_j} \con \Sigma_{i_j}.
  \]
\end{proposition}
\begin{proof}
  We argue by induction on $n$.
  For languages returned by \texttt{derivative}, the inductive step follows by
  \[
    \efree{\Sigma_n\deriv{s}} \ =\
    \efree{\efree{\Sigma_n}\deriv{s}} \ =\
    \efree{\bigcup_j \bigcup_{\Lambda' \in \efree{\Lambda_j}\deriv[split]{s}} \Lambda' \con \Sigma_{i_j}} \ =\
    \bigcup_{\substack{j \\ \Lambda' \in \Lambda_j\deriv[split]{s}}} \efree{\Lambda'} \con \Sigma_{i_j}
      \ \cup\  \bigcup_{\substack{j \\ \epsilon \in \Lambda' \in \Lambda_j\deriv[split]{s}}} \efree{\Sigma_{i_j}},
  \]
  and applying the inductive hypothesis to the latter part of the sum. All other cases are trivial.
\end{proof}

Our proposed data structure keeps, for each $\Sigma_n$, the set of pairs warranted above,
and an additional bit denoting whether $\epsilon \in \Sigma_n$.
All operations have natural implementations, with \texttt{derivative} following the above proof.
Their complexity will be analyzed in Section~\ref{sec:complexity}.
Here, we note only that, as language union is idempotent, any duplicate pairs encountered can (and should) be merged.
Thus, each $\Sigma_n$ is represented by at most $n\,|\mathcal{L}|$ pairs.

The whole structure can be viewed as a DAG, whose vertices correspond to the languages $\Sigma_i$.
Edges, labeled with elements of $\mathcal{L}$, follow the references from Proposition~\ref{prop:language-shape}:
an edge $(u, v)$ with label $\Lambda$ is present iff the decomposition of $\efree{\Sigma_u}$ contains the pair $(\Lambda, v)$.
Each vertex is additionally labeled with the $\epsilon$ bit---vertices at which this bit is set will be called \term{final}.


\subsection{Parsing relations}

We will now augment the above simple data structure so that it represents mixed relations instead of languages.
Capturing the properties of atomic relations requires an appropriate definition of regularity.
It is however not enough to use a nondeterministic variant of Definition~\ref{def:derivative-rel}---%
the symbols by which derivatives are taken cannot be removed alone, but need to be paired with corresponding parts of the derivation.

\begin{definition}
    A \term{split derivative of degree $k$} of a mixed relation $\Psi \subseteq M^*{\times}D^*$ by a symbol $s \in S$
    is any collection of pairs $\Psi\deriv[split]{s} = \{ (\Pi_i, \Psi_i) \}_{i = 1 \ldots k}$
    with $\Pi_i \subseteq D^*{\times}D^*$ and $\Psi_i \subseteq M^*{\times}D^*$
    such that for every $\mu \in M^*$ and $\delta, \eta \in D^*$ we have
    \[
        (\eta \con s \con \mu, \rev\delta) \in \Psi
        \quad\iff\quad
        (\eta \con s \con \mu, \rev\delta) \in \bigcup_i \Pi_i \con (s, \epsilon) \con \Psi_i.
    \]

    A mixed relation is \term{$(m, k)$-regular} if is belongs to a family of size $m$ closed under split derivatives of degree $k$.
\end{definition}

Regular relations, as defined here, are similar to \emph{rational relations}---%
a well-studied generalization of regular languages~\cite{rational}.
The fundamental difference is that the latter require the components to be "jointly regular",
whereas we put no restriction on the second component.
We are only concerned about finiteness (and bounded nondeterminism) of the automaton with respect to $S$.
Note however, that despite this flexibility, such automata are not always determinizable.

\begin{lemma}
    \label{lem:atomic-regular-rel}
    Atomic relations for the grammar $G$ are $(|G|, |G|)$-regular.
\end{lemma}
\begin{proof}
    The relation $\nulling{\{(s\start, \epsilon)\}}$ is $(2,1)$-regular,
    with the required family consisting of itself and $\{(\epsilon,\epsilon)\}$.

    Let us define a \term{position} to be a derivation rule with a marker $\position$ placed somewhere in its right-hand side.
    Denote the set of positions by $P$, i.e.
    \[ P \deq \{ s \produces \alpha \position \beta \suchthat (s \produces \alpha \con \beta) \in D \}. \]

    Now, define the following families of relations:
    \begin{align*}
        \Phi_{s, u} &\deq [(s, \epsilon)]\deriv{u}
            &\text{indexed by } s, u \in S,\\
        \Phi_{s, u \produces \alpha \position \beta} &\deq (\beta, (u \produces \alpha \con \beta)) \con [(s, \epsilon)]\deriv{u}
            &\text{indexed by } s \in S \text{ and } (u \produces \alpha \position \beta) \in P.
    \end{align*}

    We claim that these relations satisfy the following equations:
    \begin{align*}
        \Phi_{s, u \produces \alpha \position}
            &\quad=\quad (\epsilon, u \produces \alpha) \con \Phi_{s, u},\\
        \Phi_{s, u \produces \alpha \position v \con \beta}
            &\quad=\quad (v, \epsilon) \con \Phi_{s, u \produces \alpha \con v \position \beta},\\
        \Phi_{s, u}
            &\quad=\quad \bigcup_{(v \produces \alpha \con u \con \beta) \in D} (\{\epsilon\} {\times} \rev{\nulling\alpha \cap D^*}) \con \Phi_{s, v \produces \alpha \con u \position \beta}
            \quad\cup\quad \{ (\epsilon,\epsilon) \text{ if } s = u \}.
    \end{align*}
    %(note that for an $\alpha \in S^*$, the language $\nulling\alpha \cap D^*$ contains exactly those derivations which erase $\alpha$, i.e.
    %$\{ \delta \in D^* \suchthat \alpha \derives[\delta] \epsilon \}$).

    The first two equalities follow immediately from the definitions.
    To prove the third, take $(\sigma, \rev\delta) \in \Phi_{s, u}$, i.e. $s \lderives[\delta] u \con \sigma$.
    If $\delta = \epsilon$, then $\sigma = \epsilon$ and $s = u$.
    Otherwise the left-linear derivation $\delta$ must be of the form
    \[
        s \lderives[\delta'] v \con \gamma
            \lderives[d = (v \produces \alpha \con u \con \beta)] \alpha \con u \con \beta \con \gamma
            \lderives[\delta''] u \con \beta \con \gamma
            = u \con \sigma,
    \]
    with $\delta = \delta' \con d \con \delta''$ and $\delta'' \in \nulling\alpha$
    meaning that
    \[
        (\sigma, \rev\delta)
            \in (\{\epsilon\}{\times} \rev{\nulling\alpha \cap D^*}) \con (\beta, d) \con [(s, \epsilon)]\deriv{v}
            = (\{\epsilon\}{\times} \rev{\nulling\alpha \cap D^*}) \con \Phi_{s, v \produces \alpha \con u \position \beta}.
    \]

    Denoting by $E_\alpha$ the language of derivations which erase $\alpha$, i.e.
    $E_\alpha \deq \nulling\alpha \cap D^*$,
    and applying nulling to the above equations we obtain
    \begin{align*}
        \nulling{\Phi_{s, u \produces \alpha \position}}
            &\quad=\quad (\epsilon, u \produces \alpha) \con \nulling{\Phi_{s, u}},\\
        \nulling{\Phi_{s, u \produces \alpha \position v \con \beta}}
            &\quad=\quad (v, \epsilon) \con \nulling{\Phi_{s, u \produces \alpha \con v \position \beta}}
            \quad\cup\quad
            (E_v{\times}\{\epsilon\}) \con \nulling{\Phi_{s, u \produces \alpha \con v \position \beta}},\\
        \nulling{\Phi_{s, u}}
            &\quad=\quad \bigcup_{(v \produces \alpha \con u \con \beta) \in D} (\{\epsilon\}{\times}\rev{E_\alpha}) \con \nulling{\Phi_{s, v \produces \alpha \con u \position \beta}}
            \quad\cup\quad \{ (\epsilon,\epsilon) \text{ if } s = u \}.
    \end{align*}

    Observe that in the equations above, $s$ directly influences only whether the final $(\epsilon, \epsilon)$ component is included or not---%
    the relations between $\Phi_{s, x}$ for different $x$'s do not depend on it.
    To conveniently capture these relations, let us introduce the \term{atomic graph} of the grammar $G$,
    with vertices corresponding to symbols (denoted $a_s$ for $s \in S$) and positions (denoted $a_p$ for $p \in P$).
    The vertices are connected with the following directed edges,
    all labeled with relations over derivations, i.e., subsets of $D^*{\times}D^*$:
    \begin{align*}
        a_v \edge[\{\epsilon\}{\times}\rev{E_\alpha}] a_{u \produces \alpha \con v \position \beta}
            &\quad\text{for each } (u \produces \alpha \con v \con \beta) \in D \text{ with } E_\alpha \neq \varnothing,\\
        a_{u \produces \alpha \position} \edge[\{(\epsilon, (u \produces \alpha))\}] a_u
            &\quad\text{for each } (u \produces \alpha) \in D, \text{ and}\\
        a_{u \produces \alpha \position v \con \beta} \edge[E_v{\times}\{\epsilon\}] a_{u \produces \alpha \con v \position \beta}
            &\quad\text{for each } (u \produces \alpha \con v \con \beta) \in D \text{ with } E_v \neq \varnothing.
    \end{align*}

    Denote by $\Pi_{x, y} \subseteq D^*{\times}D^*$ the cumulative label of all paths from vertex $a_x$ to $a_y$, i.e.
    \[ \Pi_{x, y} \deq \bigcup_{a_x = a_0 \edge[\Pi_1] a_1 \edge[\Pi_2] \ldots \edge[\Pi_k] a_k = a_y} \Pi_1 \cons \Pi_k. \]

    One can now easily establish that
    \[
        (\eta \con v \con \mu, \rev\delta) \in \nulling{\Phi_{s, x}}
        \quad\iff\quad
        (\eta \con v \con \mu, \rev\delta) \in \bigcup_{(u \produces \alpha \con v \con \beta) \in D} \Pi_{x, u \produces \alpha \position v \con \beta} \con (v, \epsilon) \con \nulling{\Phi_{s, u \produces \alpha \con v \position \beta}},
    \]
    which shows that for each $s \in S$,
    the family of size $|G|$ consisting of all $\nulling{\Phi_{s, x}}$ (including $\nulling{[(s, \epsilon)]\deriv{t}}$)
    is closed under split derivatives of degree $|G|$.
\end{proof}

Analogously to what we have done with $\TS$,
we can now parameterize the type $\TP$ with an arbitrary finite family $\mathcal{R}$ of relations, closed under split derivatives.
The implementation is based on the following generalization of Proposition~\ref{prop:language-shape},
with the $\epsilon$-free part of a mixed relation $\Psi$ being $\efree\Psi \deq \Psi - D^*{\times}D^*$:

\begin{proposition}
    \label{prop:relation-shape}
    Let $\Psi_1, \Psi_2, \ldots, \Psi_n$ be a sequence of mixed relations (subsets of $M^*{\times}D^*$),
    in which each $\Psi_i$ is obtained by applying one of the primitive relation operations to some $\Psi_j$ with $j < i$.
    Then there exists a finite collection of triples $\{ (\Pi_j, \Gamma_j, i_j) \}_{j}$
    with $\Pi_j \subseteq D^*{\times}D^*$, $\Gamma_j \in \mathcal{R}$ and $1 \leqslant i_j < n$, such that
    \[
        \efree{\Psi_n} = \bigcup_j \Pi_j \con \efree{\Gamma_j} \con \Psi_{i_j}.
    \]
\end{proposition}
\begin{proof}
    Analogously to the proof of Proposition~\ref{prop:language-shape}, we argue by induction on $n$.
    Again, the only nontrivial case is computing derivatives.
    Let us introduce the following auxiliary operation, called \term{flattening},
    defined on any $\Pi \subseteq D^*{\times}D^*$:
    \[ \Pi^\flat \deq \{ (\epsilon, \rev{\delta \con \eta}) \suchthat (\eta, \rev\delta) \in \Pi \}. \]

    Assuming $\efree{\Psi_n} = \bigcup_j \Pi_j \con \efree{\Gamma_j} \con \Psi_{i_j}$,
    we obtain
    \begin{align*}
        \efree{\Psi_n\deriv{s}}
        &= \efree{\efree{\Psi_n}\deriv{s}}
        = \efree{\bigcup_j (\Pi_j \con \efree{\Gamma_j} \con \Psi_{i_j})\deriv{s}}
        = \efree{\bigcup_{\substack{j \\ (\Pi,\Gamma) \in \Gamma_j\deriv[split]{s}}} (\Pi_j \con \Pi)^\flat \con \Gamma \con \Psi_{i_j}} \\
        &= \bigcup_{\substack{j \\ (\Pi,\Gamma) \in \Gamma_j\deriv[split]{s}}} (\Pi_j \con \Pi)^\flat \con \efree\Gamma \con \Psi_{i_j}
        ~\cup~ \bigcup_{\substack{j \\ (\Pi,\Gamma) \in \Gamma_j\deriv[split]{s}}} (\Pi_j \con \Pi)^\flat \con (\Gamma \cap D^*{\times}D^*) \con \efree{\Psi_{i_j}}.
    \end{align*}
    By inductive hypothesis, each of $\efree{\Psi_{i_j}}$ has the desired form,
    and thus so has $\efree{\Psi_n\deriv{s}}$.
\end{proof}

By the above proposition we augment our DAG as follows.
The label of each edge is now a pair $(\Pi, \Gamma)$ with $\Pi \subseteq D^*{\times}D^*$ and $\Gamma \in \mathcal{R}$.
Parallel edges labeled with the same $\Gamma$ are still merged,
with the resulting combined edge obtaining the union of their $\Pi$ labels.
Instead of the single $\epsilon$ bit,
each vertex is now labeled with a $\Pi \subseteq D^*{\times}D^*$---%
\term{final} vertices are those for which $\Pi \neq \varnothing$.


\subsection{Derivation relations}



\section{Complexity}
\label{sec:complexity}

We will now show that the input-related complexity of Algorithm~\ref{alg:recognition},
run using the representations of languages given in Section~\ref{sec:representations},
matches that of Earley parser~\cite{earley} with Leo's improvement~\cite{leo}.
To our best knowledge this is the best among state-of-the-art generalized parsers.

\begin{proposition}
  \label{prop:complexity-cubic}
  A sequence of $n$ primitive operations on languages takes time $O(n^3)$.
\end{proposition}
\begin{proof}
  As noted before, each language in such a sequence can be represented by at most $n\,|\mathcal{L}| = O(n)$ pairs.
  When computing \texttt{derivative}, one possibly needs to examine (and combine) the representations of all $\Sigma_{i_j}$ "directly referenced" by the current $\Sigma_n$.
  This takes time $O(n^2)$.
  Running times of \texttt{union} and \texttt{prepend} are linear in the size of their arguments,
  and the remaining operations are $O(1)$.
  Summing over the sequence of $n$ operations gives the desired $O(n^3)$.
\end{proof}

\begin{corollary}
  Recognizing an input of length $n$ takes time $O(n^3)$.
\end{corollary}

To be able to give better complexity bounds for restricted classes of grammars,
we will make the standard natural assumption that each symbol in the grammar is \term{productive},
i.e., derives some (possibly empty) terminal word.
Detecting and removing non-productive symbols can be easily done during parser generation.

The consequence of this assumption is that every \emph{sequence} of symbols also is productive.
This allows us to prove the following:

\begin{proposition}
  \label{prop:complexity-quadratic}
  When the grammar is unambiguous, recognition takes time $O(n^2)$.
\end{proposition}
\begin{proof}
  Each way a sequence $\sigma \in S^*$ can be placed in $\nulling{\Sigma_\tau}$
  can be attributed to some unique derivation $s\start \derives[*] \tau \con \sigma$
  (the derivation is leftmost, with the exception that if any symbol occurrence is erased,
  such erasure happens immediately after the occurrence is introduced).
  Should any $\sigma$ have more than one such derivation, the grammar would be ambiguous.
  This implies that, for unambiguous grammars, all unions---%
  those requested explicitly and those performed internally by \texttt{derivative}, are in fact disjoint.
  This makes each operation run in time proportional to the size of its result (i.e., the outdegree of the vertex created).
  Consequently, the complexity of the \emph{whole sequence} of operations is linear in the size of the complete DAG constructed.
  The result follows.
\end{proof}

It turns out that for LR-regular grammars
(see~\cite{lr-regular}; this class contains LR(k) for all k, and thus most deterministic grammars),
the size of the DAG is always linear in the input length.
Showing this requires a careful analysis of when edges are created.
Vertices which are subsequently passed as an argument to \texttt{union} can be accounted for at the result of such union.
For other vertices, one can show the following technical lemma:

\begin{lemma}
    \label{lem:edges}
    Every edge labeled $\Lambda$ from a vertex representing $\nulling{\Sigma_{\tau \con \rho}}$ to a vertex representing $\nulling{\Sigma_\tau}\deriv{s}$
    is witnessed by its own distinct derivation $s \derives[*] \rho \con \Lambda$.
    Every edge labeled $\Lambda$ from a vertex representing $\nulling{\Sigma_{\tau \con \rho}}\deriv{s'}$ to a vertex representing $\nulling{\Sigma_\tau}\deriv{s}$
    is witnessed by its own distinct derivation $s \derives[*] \rho \con s' \con \Lambda$.
    There are no other edges.
\end{lemma}
\begin{proof}
    The third statement is easily established by looking at data dependencies between language operations performed by the algorithm.
    The first two can be proven by simultaneous induction on the length of $\rho$.
\end{proof}

\begin{lemma}
    \label{lem:lr-regular}
    (cf.~\cite{leo}, Lemma~4.7)
    When the grammar is LR-regular, there exists an equivalence relation $\equiv$ on $S^*$ with finitely many classes,
    such that for any two derivations
    \[
        s\start \derives[*] \tau \con s \con \gamma \derives[*] \tau \con \rho \con \delta \con \gamma
        \quad\text{ and }\quad
        s\start \derives[*] \tau' \con s \con \gamma' \derives[*] \tau' \con \rho' \con \delta \con \gamma'
    \]
    with $\tau \con \rho = \tau' \con \rho'$, $\delta \neq \epsilon$ and $\gamma \equiv \gamma'$, we have $\tau = \tau'$.
\end{lemma}

\begin{proposition}
  \label{prop:complexity-linear}
  When the grammar is LR-regular,
  the outdegree of each DAG node is $O(1)$.
\end{proposition}
\begin{proof}
    \textit{(Sketch)}
    Fix a prefix $\nu$ of the input string, an $s \in S$, and a label $\Lambda \in \mathcal{L}$.
    Consider all edges labeled $\Lambda$ going from $\nulling{\Sigma_\nu}$ to $\nulling{\Sigma_\tau}\deriv{s}$ for any $\tau$.
    For each such $\tau$ there must exist a $\rho$ such that $\nu = \tau \con \rho$.

    We can take the derivations $s \derives[*] \rho \con \Lambda$ "backing" these edges by Lemma~\ref{lem:edges}
    and extend them (by nonemptyness of $\nulling{\Sigma_\tau}\deriv{s}$ and $\efree\Lambda$)
    so that Lemma~\ref{lem:lr-regular} can be applied to them.
    By finiteness of $\equiv$ we conclude that the number of such edges,
    and thus all edges leaving $\nulling{\Sigma_\nu}$,
    is $O(1)$.

    The argument for edges leaving $\nulling{\Sigma_\nu}\deriv{s'}$ is analogous.
\end{proof}

\begin{corollary}
  When the grammar is LR-regular,
  recognition takes time $O(n)$.
\end{corollary}


\section{Memoization}
\label{sec:memoization}

We find the mathematical clarity of our algorithm to be a virtue on its own.
In particular, it opens a clear way of investigating potentially more effective data representations,
and making use of language-theoretic algorithms, like optimization of nondeterministic automata.
However, a practical aspect we find especially beneficial is the immutability of the intermediate objects computed during parsing.
This is because it allows memoizing and reusing the results of computation.
We report on this aspect in this section.

To show the possible effects of memoization on parsing actual programming languages,
we have chosen a grammar for Java 8 from the ANTLR4 grammar repository
(\url{https://github.com/antlr/grammars-v4/blob/master/java8/Java8.g4};
this grammar is ambiguous, but extremely close to the Java language specification)
and a large, popular Java project (\texttt{elasticsearch-6.5.3}, with 9596 \texttt{.java} files totalling over 10 million terminals).

\subsection*{Trivial memoization}

The most obvious way in which one can reuse the results of previous phases of computation is the following:
consider two input prefixes $\tau$ and $\tau'$ for which $\nulling{\Sigma_{\tau'}} = \nulling{\Sigma_\tau}$
(this might happen if the two prefixes have the same set of "possible completions" according to $G$).
If such equality is discovered (i.e., the languages have identical representation),
and both $\tau$ and $\tau'$ are followed by the same terminal $t$,
the language $\nulling{\Sigma_{\tau \con t}}$ can be reused as $\nulling{\Sigma_{\tau' \con t}}$.
In practice, this happens both within a single input, and across multiple inputs.
On our test suite, over 94\% of phase computations have been taken from cache.
Computing the remaining 6\% took 96\% of total recognition time---%
this shows how expensive the DAG operations are compared to a simple dictionary lookup.

\subsection*{Dominator-based memoization}

To further develop our intuition on the parsing languages,
imagine a syntactic construct requiring a specific final terminal $f$ (e.g., a closing bracket).
When our "textbook PDA" definitely (i.e., having locally no other viable nondeterministic choice)
applies a rule for such construct, say, $s \produces \sigma \con f$,
the sequence $\sigma \con f$ is placed on its (every possible) stack---%
in our terms, it becomes a prefix of every word in the current parsing language.
This occurrence of $f$ can only be removed once $f$ is encountered in the input string.
Before this happens, all parsing languages will be of the form $\Sigma \con f \con \Delta$,
with varying $\Sigma$, but fixed $\Delta$.
The contents of $\Delta$, being "guarded" by $f$,
can have no influence on the operations performed to the left of $f$.
Thus one could memoize only the relevant prefix of the parsing language,
and reuse such partial results of computation whenever the same relevant prefix is encountered,
regardless of what lies to the right.

To make use of the above observation, we need to complicate our representation $\TS$ of languages.
The DAG described in Section~\ref{sec:representations} will still be used internally.
However, instead of a single DAG vertex, each element of $\TS$ will now be a \emph{stack} of such vertices.
The language represented by such stack is the concatenation (top-to-bottom) of the languages represented by individual vertices.
We do this in order to detect if a phase can be computed looking at only some prefix of the current language,
and to reuse such computation should the same prefix be encountered again.

The derivative a concatenation of two languages $(\Sigma_1 \con \Sigma_2)\deriv{s}$ is equal to $\Sigma_1\deriv{s} \con \Sigma_2$
(and thus computing it does not require looking at $\Sigma_2$) unless $\epsilon \in \Sigma_1$.
Therefore we require all but the bottom stack vertex \emph{not} to be final.
To maintain this invariant, should we ever attempt to push a final vertex $v$ on top of a nonempty stack,
we will instead replace the current top vertex $w$ with one representing the concatenation of languages of $v$ and $w$
(such concatenation becomes yet another operation of the underlying DAG structure).

When computing each $\nulling{\Sigma_{\tau \con t}}$ from $\nulling{\Sigma_\tau}$,
we keep track of how deep down the current stack we have looked in order to restore the invariant.
When a phase is over, its result is a single DAG vertex (say, $v$), to be pushed on top of the part of the stack which has not been examined.
However, the language represented by $v$ might contain some "guarding" symbols,
as described in the introductory paragraph of this subsection.
Discovering such inner structure is necessary to allow future phases to work on a smaller relevant prefix of the parsing language.
Thus, the language represented by $v$ is \term{factorized}:
in the DAG, we consider all paths leading from $v$ to any final vertex,
and compute the set of \term{dominators}---vertices occurring on every such path.
Then, the fragments of the DAG between successive dominators are encoded as individual vertices,
say $v_1, \ldots, v_k$, and those are pushed on the stack instead of $v$.

Memoization itself is performed in a trie,
mapping the phase terminal $t$ and the sequence of top stack vertices examined during phase computation
(because only taking derivatives can turn a non-final vertex into a final one, the length of such sequence is at most three)
into the resulting sequence of vertices $v_1, \ldots, v_k$.
Whenever the current input terminal together with the top of the stack is found in the trie,
such memoized phase computation requires only a handful of simple stack operations.
In our test suite, this happens in over 99.7\% of phases---%
the remaining 0.3\% now take about 40\% of total recognition time.

\subsection*{Recognition speed}

\begin{figure}
  \centering
  \begin{tabular}{l|r|r}
    algorithm & time [s] & memory [GB] \\
    \hline\hline
    GLL & 2445.6 & 0.32 \\
    GLL (non-optimized grammar\footnotemark) & 470.2 & 0.15 \\
    \hline
    relational (no memoization) & 751.4 & 2.42 \\
    relational (trivial memoization) & 77.5 & 3.22 \\
    relational (dominator-based memoization) & 7.8 & 0.22 \\
    relational (dominator-based, non-optimized) & 30.3 & 1.08 \\
    \hline
    \texttt{javac} (parser) & 14.0 & 0.93 \\
    \hline
  \end{tabular}
  \caption{Running times and memory usage of compared recognition algorithms.}
  \label{fig:timings}
\end{figure}

\footnotetext{The grammar given to both GLL and our parser has been left-factored
and then optionally optimized by simple partition refinement analogous to Moore's method of minimizing finite automata.
While this optimization has helped our method (reducing the cardinality of $\mathcal{L}$ from 5503 to 2949),
it has made GLL perform significantly worse by making its GSS denser.}

Even though our proof-of-concept implementation has not been created with speed in mind,%
\footnote{It has multiple additional layers of abstraction, useful for experimenting with different language representations.
In C$\sharp$, the overhead of these layers cannot be eliminated at compile-time and must be paid during parsing.
It seems a well-structured C++ implementation could do significantly better.}
we have decided to provide here a short "raw speed" comparison between our algorithm, GLL, and the hand-coded parser being part of the current Java 8 compiler \texttt{javac}.
The timings have been taken on a modest laptop, with 3 GHz Intel Core i7 CPU and 8 GB of RAM, running 64-bit Linux.
All parsers have been restricted to use a single CPU core,
and memory usage has been measured for the whole process, including .NET Core or Java VM.

The results are gathered on Figure~\ref{fig:timings}.
Note that, while all other timings are for parsers, the one for \texttt{javac} includes tokenizing the input and building parse trees.
However, in a hand-coded, deterministic parser, we would not expect these two tasks to take significantly more than half of total execution time.
Also, these results are for recognition: generating parse forests using our method \emph{is} fast, but not \emph{that} fast---%
for details, please consult the full version.


\section{Related work}
\label{sec:related}

Parsing is a vast subject (see, e.g.~\cite{grune}),
thus here we only touch on what we find to be most relevant to our algorithm.
We also hint at some potential future improvements.

\subsection*{Simulating nondeterministic pushdown automata}

Effective simultaneous simulation of possible runs of a PDA has been proposed by Lang~\cite{pda-simulation}.
In~\cite{tomita,gss}, Tomita presented the graph-structured stack as a convenient structure for capturing such nondeterminism.
This has led to a multitude of generalized parsers, differing primarily by the automaton being simulated:
this includes the GLR family (e.g.,~\cite{brnglr}), GLC~\cite{glc,glc-improved}, and GLL~\cite{gll,gll-performance}.

It seems perfectly possible to adjust our main algorithm to simulate an arbitrary pushdown automaton,
while still requiring a constant number of operations on $\TS$ to compute a single phase.
In fact, our implementation uses recursive transition networks~\cite{rtn} instead of the "textbook" PDA described here,
as they make it easier to enrich the parser with additional features.
We have not yet attempted to compare the efficiency of such different encodings of context-free grammars.

The Adaptive LL(*) algorithm~\cite{allstar}, underlying the popular ANTLR4 parser generator, uses simulation to predict valid transitions.
It represents configuration sets explicitly, and thus fails to handle left-recursive grammars, where these sets can be infinite.
Our approach, originally aimed to remove this restriction, abstracts away the specific representation.

\subsection*{Left- and right-recursive productions}

For top-down (predictive) parsers, left-recursive productions are inherently problematic,
because it is difficult to know up front how many times a left-recursive loop should be followed.
Thus, most algorithms in the LL family refuse to handle such grammars.
GLL captures \emph{all} possible runs through left recursion by introducing cycles into its graph-structured stack,
and so does Earley's algorithm (cyclicity here takes the form of an item referencing its own layer).

Right recursion requires special attention when reduction possibilities are considered,
because it may happen that a new way of reaching some state is discovered \emph{after} it has been "processed".
All nondeterminism-simulating parsers handle this using work queues or other mutable data structures.
Similar care (and mutability) is needed in Earley-style parsers.

With simultaneous left and right recursion,
the grammar is infinitely ambiguous,
and thus the final result of parsing \emph{must} be cyclic.
Relational parsing integrates both left and right recursion into the atomic languages,
thus completely avoiding the need for cyclic structures and mutation during parsing.
To our best knowledge it is the first algorithm with this property.

Right recursion influences also the complexity of generalized parsers,
as it can make linearly long sequences of reductions (completed production rules) available at each input position.
Some parsers, including Earley's, use lookahead to avoid incurring quadratic complexity on LR(k) grammars.
Another approach, used in Leo's modification~\cite{leo} and applicable to all LR-regular grammars \emph{without} using lookahead,
is to create shortcuts through such long reduction paths.
This is precisely what we achieve by the decomposition proposed in Proposition~\ref{prop:language-shape}.

\subsection*{Nullable symbols}

Nullable nonterminals seem to be a nuisance for every parsing algorithm.
Although in theory one can easily avoid dealing with them by first rewriting the grammar,
it is impractical to do so: binary grammars can grow quadratically, and arbitrary ones---exponentially.
Right-nulled GLR~\cite{rnglr,rnglr-optimize} avoids the exponential blow-up by only eliminating trailing nullables in each production.
Most other algorithms attempt to handle all nullables "on the fly".
In our case, this amounts to taking the nullings of the atomic languages, as shown in Section~\ref{sec:nullables}.
While it does not cause the automata representing them to have more states,
additional edges \emph{are} introduced and traversed.

In an analogous situation, the version of CYK presented in~\cite{cyk-2nf} does \emph{not} precompute the extra edges.
Instead it avoids higher grammar-related complexity by grouping together multiple walks
on the graph representing derivations between single nonterminals.
It is interesting whether this idea could somehow be adapted to our setting,
thus lowering the worst-case complexity of our method wrt. grammar size.

\subsection*{Atomic languages vs.~left corners}

The slightly less popular GLC parser builds a bridge between top-down and bottom-up parsing by using the \term{left corner relation},
containing a pair of nonterminals whenever one of them can appear leftmost in some derivation from the other.
Our proposed representation of atomic languages by NFAs has states indexed by pairs of symbols related in exactly the same way,
and the transitions in these automata mirror appropriate rules of GLC.

The authors of GLC propose to make the algorithm more effective by grouping some of the cases heuristically.
With our approach, it is clear that one could use any automaton recognizing the same language.
This opens the way for well-understood optimizations.

\subsection*{Limiting stack activity}

It is well known that the primary source of inefficiency in generalized parsers is handling large graph-like data structures (like the GSS), offering poor cache locality.
Reduction-incorporated parsers (cf.~\cite{riglr}) attempt to limit the size of these graphs by handling most of the grammar using finite automata, and using the stack only when necessary.
Appropriate pushdown automata can be constructed in multiple ways,
and thus in~\cite{riglr-optimize} the authors suggest selecting the best one by profiling the parser on sample inputs.

In our algorithm, all activity between successive terminals is handled by the automata for atomic languages.
Also, instead of limiting the depth of the (multiple) stacks, we perform most---even locally ambiguous---operations on a \emph{single}, \emph{plain} stack.
With dominator-based memoization, the algorithm learns the right stack actions \emph{while} parsing,
though one could also possibly train it beforehand on some sample inputs.

\subsection*{Memoization}

Memoization has been put to great use in the Adaptive LL(*) parsing algorithm,
even though it is only used there when predicting the right nondeterministic choice.
To make memoized computations applicable in more situations,
the algorithm pretends to forget all but the top state of its PDA (specifically, a recursive transition network).
If such "blind" computation succeeds, it can then be applied on top of any stack.
However, should it fail, the algorithm resorts to non-memoized computation with full stack information.
Our dominator-based memoization handles analogous situations better, and in a way optimally:
we always look at exactly such stack depth as is necessary.

\subsection*{Using Brzozowski derivatives for parsing}

Taking derivatives by successive input symbols is the approach in the "parsing with derivatives (PWD)" algorithm,
proposed by Might et al.~\cite{derivatives,derivatives-fast}.
The intermediate languages computed by PWD are context-free (usually non-regular),
and consequently the algorithm requires careful handling of mutable, cyclic structures.
With our approach, thanks to the interleaved left-linear closure steps, one needs to deal with regular languages only.
The memoization of computed derivatives employed in PWD, necessary for obtaining practical parsing speeds,
roughly corresponds to our "trivial" memoization of whole parsing languages.
We do not see how the better dominator-based approach could be applied to PWD,
precisely due to mutability of its language representations.

\subsection*{Semantics}

As far as we know, no previous generalized parsing algorithm \emph{explicitly} computes the languages of reachable configurations.
However, these languages are implicitly present in \emph{all} of them,
and often could be easily read off their data structures after processing each terminal:
in GLL for example, reachable configurations of the appropriate pushdown automaton are precisely all the paths through the GSS.

We believe that our semantics-based approach opens the way not only to cleaner and more performant parsers for all context-free languages,
but possibly also to handling larger useful grammar classes,
beginning with conjunctive grammars~\cite{conjunctive} or even grammars with one- or two-sided contexts~\cite{glr-with-contexts,bicontexts,recognize-bicontexts}.



\bibliographystyle{plainurl}
\bibliography{parsing}

\end{document}
